Index: trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 78883)
+++ trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 78884)
@@ -690,5 +690,5 @@
         QPainter painter(this);
         QFont painterFont(font());
-        painterFont.setPixelSize(16);
+        painterFont.setPixelSize(15);
         painter.setFont(painterFont);
         painter.setRenderHint(QPainter::Antialiasing);
@@ -704,7 +704,6 @@
                 painter.translate(key.keyGeometry().x(), key.keyGeometry().y());
                 painter.drawPolygon(key.polygon());
-                QRect textRect(0, 0, key.keyGeometry().width(), key.keyGeometry().height());
-                //painter.drawText(textRect, Qt::TextWordWrap, key.keyCap());
-                painter.drawText(textRect, Qt::TextWordWrap, QString::number(key.position()));
+                QRect textRect(5, 5, key.keyGeometry().width(), key.keyGeometry().height());
+                painter.drawText(textRect, Qt::TextWordWrap, key.keyCap());
                 painter.translate(-key.keyGeometry().x(), -key.keyGeometry().y());
             }
@@ -724,5 +723,4 @@
                 if (key.polygonInGlobal().containsPoint(eventPosition, Qt::OddEvenFill))
                 {
-                    //printf ("%s\n", qPrintable(key.keyCap()));
                     break;
                 }
Index: trunk/src/VBox/Frontends/VirtualBox/xml/102_iso.xml
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/xml/102_iso.xml	(revision 78883)
+++ trunk/src/VBox/Frontends/VirtualBox/xml/102_iso.xml	(revision 78884)
@@ -87,5 +87,6 @@
         </key>
         <key>
-            <keycap>ScrollLock</keycap>
+            <keycap>Scroll</keycap>
+            <keycap>Lock</keycap>
             <position>125</position>
             <scancode>0x46</scancode>
@@ -202,5 +203,5 @@
         </key>
         <key>
-            <keycap>Page Up</keycap>
+            <keycap>PgUp</keycap>
             <position>85</position>
             <scancodeprefix>0xe0</scancodeprefix>
@@ -208,5 +209,4 @@
         </key>
     </row>
-    <!-- ======================================= -->
     <row>
         <key>
@@ -283,5 +283,5 @@
             <keycap>Enter</keycap>
             <position>43</position>
-            <scancode>0x2b</scancode>
+            <scancode>0x1c</scancode>
             <cutout>
                 <width>25</width>
@@ -294,17 +294,20 @@
         </space>
         <key>
-            <keycap>PrtScn</keycap>
+            <keycap>Delete</keycap>
             <position>76</position>
-            <scancode></scancode>
-        </key>
-        <key>
-            <keycap>ScrollLock</keycap>
+            <scancode>0x53</scancode>
+            <scancodeprefix>0xe0</scancodeprefix>
+        </key>
+        <key>
+            <keycap>End</keycap>
             <position>81</position>
-            <scancode>0x46</scancode>
-        </key>
-        <key>
-            <keycap>ScrollLock</keycap>
+            <scancodeprefix>0xe0</scancodeprefix>
+            <scancode>0x4f</scancode>
+        </key>
+        <key>
+            <keycap>PgDn</keycap>
             <position>86</position>
-            <scancode>0x46</scancode>
+            <scancode>0x51</scancode>
+            <scancodeprefix>0xe0</scancodeprefix>
         </key>
     </row>
@@ -378,5 +381,5 @@
             <keycap>'</keycap>
             <position>42</position>
-            <scancode>0x28</scancode>
+            <scancode>0xff</scancode>
         </key>
     </row>
@@ -460,6 +463,7 @@
         <key>
             <keycap>Up</keycap>
+            <scancodeprefix>0xe0</scancodeprefix>
             <position>83</position>
-            <scancode>0x35</scancode>
+            <scancode>0x48</scancode>
         </key>
     </row>
@@ -521,15 +525,18 @@
             <keycap>Left</keycap>
             <position>79</position>
-            <scancode>0x35</scancode>
+            <scancodeprefix>0xe0</scancodeprefix>
+            <scancode>0x4b</scancode>
         </key>
         <key>
             <keycap>Down</keycap>
             <position>84</position>
-            <scancode>0x35</scancode>
+            <scancodeprefix>0xe0</scancodeprefix>
+            <scancode>0x50</scancode>
         </key>
         <key>
             <keycap>Right</keycap>
             <position>89</position>
-            <scancode>0x35</scancode>
+            <scancodeprefix>0xe0</scancodeprefix>
+            <scancode>0x4d</scancode>
         </key>
 